program rippel3;

uses japi, japiKern, Modul;

CONST
  m = 1001;
  n = 501;

var datei, neu , Taste  : integer;
  first :integer;

  schichthoehe : ARRAY[0..m,0..n] OF SHORTINT;
  grenze, k, anfhoehe, xmax, ymax, q,g : INTEGER;
  b, Windstaerke : REAL;
  grenzeStr, bStr, WindstaerkeStr, qStr, xmaxStr, ymaxStr,
  anfhoeheStr : STRING;
  Beleuchtung, Umrandung : BOOLEAN;


PROCEDURE init;
  var i,j : integer;
  BEGIN
    FOR i:=0 TO m DO
      FOR j:=0 TO n DO
        schichthoehe[i,j]:=0;
    FOR i:=0 TO xmax DO
      FOR j:=0 TO ymax DO
        schichthoehe[i,j]:=anfhoehe;
  END; {init}

PROCEDURE zeigen(grenze:INTEGER);
VAR
  i,j : INTEGER;
BEGIN
  loeschebildschirm(schwarz);
  i:=0;
  REPEAT
    j:=0;
    REPEAT
      IF schichthoehe[i,j]>=grenze THEN BEGIN
        setzepunkt(xplot(i),yplot(j),gelb+random(2));
        {zeichnelinie(xplot(i),yplot(schichthoehe[i]),xplot(i+1),yplot(schichthoehe[i+1]),12);}
      END ELSE BEGIN
        setzepunkt(xplot(i),yplot(j),braun);
      END;
      INC(j,1);
    UNTIL j> ymax;
    INC(i,1);
  UNTIL i>xmax;
END; {zeigen}

PROCEDURE zeigen2(grenze:integer);
  var i,j : integer;
  BEGIN
  loeschebildschirm(schwarz);
    FOR i:=0 TO xmax DO
      FOR j:=0 TO ymax DO
        if schichthoehe[i,j]>=grenze then
         setzepunkt(xplot(i),yplot(j),gelb)
        ELSE setzepunkt(xplot(i),yplot(j),braun);

  END; {zeigen2}

FUNCTION sprungweiteL(i,j : INTEGER) : INTEGER;
BEGIN
  sprungweiteL:=ROUND(Windstaerke + (b * schichthoehe[i,j]));
END; {SprungweiteL}



PROCEDURE sandhaufen;
VAR x, i, j, breite : INTEGER;
    richtung : REAL;
BEGIN
  FOR breite:=0 TO ymax DO BEGIN
    j:=0;
    REPEAT
      INC(j);
      i:=ROUND(random*xmax);
      IF schichthoehe[i,breite]>q then begin
        x:=SprungweiteL(i,breite);
        IF (i+x<=xmax) THEN BEGIN
          schichthoehe[i,breite] := schichthoehe[i,breite] - q;
          schichthoehe[i+x,breite] := schichthoehe[i+x,breite] + q;
        END ELSE BEGIN
          schichthoehe[i,breite] := schichthoehe[i,breite] - q;
          schichthoehe[(i+x)-xmax,breite] := schichthoehe[(i+x)-xmax,breite] + q;
        END;
      END;
    UNTIL j>=xmax;
  END;
END; {sandhaufen}

FUNCTION Minimum(x,y : INTEGER): INTEGER;
{0:keine nderung, 1:+-li, 2:+-re, 3:+-hi, 4:+-vo,
 + : Abrutschen an der Stelle x,y,
 - :     "      des Nachbarn. }
VAR
  wohin,richt,diff,diffli,diffre,diffhi,diffvo : INTEGER;
BEGIN
  wohin:=0;
  richt:=0;
  diff:=0;
  diffli:=schichthoehe[x,y]-schichthoehe[x+1,y]; {1}
  diffre:=schichthoehe[x,y]-schichthoehe[x-1,y]; {2}
  diffhi:=schichthoehe[x,y]-schichthoehe[x,y-1]; {3}
  diffvo:=schichthoehe[x,y]-schichthoehe[x,y+1]; {4}
  IF ABS(diffli)>diff THEN BEGIN
    diff:=diffli;
    richt:=1;
  END;
  IF ABS(diffre)>diff THEN BEGIN
    richt:=2;
    diff:=diffre;
  END;
  IF ABS(diffhi)>diff THEN BEGIN
    richt:=3;
    diff:=diffhi;
  END;
  IF ABS(diffvo)>diff THEN BEGIN
    richt:=4;
    diff:=diffvo;
  END;
  CASE richt OF
  1 : BEGIN
        IF diffli>0 THEN wohin:=1 ELSE wohin:=-1;
      END;
  2 : BEGIN
        IF diffre>0 THEN wohin:=2 ELSE wohin:=-2;
      END;
  3 : BEGIN
        IF diffhi>0 THEN wohin:=3 ELSE wohin:=-3;
      END;
  4 : BEGIN
        IF diffvo>0 THEN wohin:=4 ELSE wohin:=-4;
      END;
  END;
  Minimum:=wohin;
END;

PROCEDURE gleiten;
VAR
  dh,k,l,i,j : INTEGER;
BEGIN
  FOR i:=0 TO xmax DO BEGIN
   IF schichthoehe[i,0]>0 THEN BEGIN
    IF schichthoehe[i,0]>schichthoehe[i,1] THEN BEGIN
      DEC(schichthoehe[i,0]);
      INC(schichthoehe[i,1]);
    END;
   END;
   IF schichthoehe[i,ymax]>0 THEN BEGIN
    IF schichthoehe[i,ymax]>schichthoehe[i,ymax-1] THEN BEGIN
      DEC(schichthoehe[i,ymax]);
      INC(schichthoehe[i,ymax-1]);
    END;
   END;
  END;
  FOR i:=0 TO ymax DO BEGIN
   IF schichthoehe[0,i]>0 THEN BEGIN
    IF schichthoehe[0,i]>schichthoehe[1,i] THEN BEGIN
      DEC(schichthoehe[0,i]);
      INC(schichthoehe[1,i]);
    END;
   END;
   IF schichthoehe[xmax,i]>0 THEN BEGIN
    IF schichthoehe[xmax,i]>schichthoehe[xmax-1,i] THEN BEGIN
      DEC(schichthoehe[xmax,i]);
      INC(schichthoehe[xmax-1,i]);
    END;
   END;
  END;

  l:=0;
  k:=0;
  REPEAT
    INC(k);
     REPEAT
       INC(l);
       i:=1+ROUND(random*(xmax-1));
       j:=1+ROUND(random*(ymax-1));
       IF (schichthoehe[i,j]>0) THEN
          CASE minimum(i,j) OF
          1 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j]-schichthoehe[i+1,j])/3);
                DEC(schichthoehe[i,j],dh);
                INC(schichthoehe[i+1,j],dh);
              END;
          2 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j]-schichthoehe[i-1,j])/3);
                DEC(schichthoehe[i,j],dh);
                INC(schichthoehe[i-1,j],dh);
              END;
          3 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j]-schichthoehe[i,j-1])/3);
                DEC(schichthoehe[i,j],dh);
                INC(schichthoehe[i,j-1],dh);
              END;
          4 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j]-schichthoehe[i,j+1])/3);
                DEC(schichthoehe[i,j],dh);
                INC(schichthoehe[i,j+1],dh);
              END;
{          -1 : BEGIN
                dh := 1+ROUND((schichthoehe[i+1,j]-schichthoehe[i,j])/3);
                INC(schichthoehe[i,j],dh);
                DEC(schichthoehe[i+1,j],dh);
              END;
          -2 : BEGIN
                dh := 1+ROUND((schichthoehe[i-1,j]-schichthoehe[i,j])/3);
                INC(schichthoehe[i,j],dh);
                DEC(schichthoehe[i-1,j],dh);
              END;
          -3 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j-1]-schichthoehe[i,j])/3);
                INC(schichthoehe[i,j],dh);
                DEC(schichthoehe[i,j-1],dh);
              END;
          -4 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j+1]-schichthoehe[i,j])/3);
                INC(schichthoehe[i,j],dh);
                DEC(schichthoehe[i,j+1],dh);
              END;}
          END;
     UNTIL l>=ymax-1;
   UNTIL k>=xmax-1;

{   END ELSE BEGIN
    FOR i:=xmax-1 DOWNTO 1 DO
     FOR j:=ymax-1 DOWNTO 1 DO
      IF ((schichthoehe[i,j]>0)AND(RANDOM<0.5)) THEN
          CASE minimum(i,j) OF
          1 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j]-schichthoehe[i+1,j])/3);
                DEC(schichthoehe[i,j],dh);
                INC(schichthoehe[i+1,j],dh);
              END;
          2 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j]-schichthoehe[i-1,j])/3);
                DEC(schichthoehe[i,j],dh);
                INC(schichthoehe[i-1,j],dh);
              END;
          3 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j]-schichthoehe[i,j-1])/3);
                DEC(schichthoehe[i,j],dh);
                INC(schichthoehe[i,j-1],dh);
              END;
          4 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j]-schichthoehe[i,j+1])/3);
                DEC(schichthoehe[i,j],dh);
                INC(schichthoehe[i,j+1],dh);
              END;
          -1 : BEGIN
                dh := 1+ROUND((schichthoehe[i+1,j]-schichthoehe[i,j])/3);
                INC(schichthoehe[i,j],dh);
                DEC(schichthoehe[i+1,j],dh);
              END;
          -2 : BEGIN
                dh := 1+ROUND((schichthoehe[i-1,j]-schichthoehe[i,j])/3);
                INC(schichthoehe[i,j],dh);
                DEC(schichthoehe[i-1,j],dh);
              END;
          -3 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j-1]-schichthoehe[i,j])/3);
                INC(schichthoehe[i,j],dh);
                DEC(schichthoehe[i,j-1],dh);
              END;
          -4 : BEGIN
                dh := 1+ROUND((schichthoehe[i,j+1]-schichthoehe[i,j])/3);
                INC(schichthoehe[i,j],dh);
                DEC(schichthoehe[i,j+1],dh);
              END;
          END;
   END;}
END; {gleiten}

Procedure simu;
var g,k : integer;
begin
  FOR g:=1 to 3 DO BEGIN
    FOR k:=1 TO 3 DO sandhaufen;
    FOR k:=1 TO (ymax) DO gleiten;
    if not(do_work) then exit;
  END;
end;



begin {Hauptprogramm}

  first:=1;

  j_setshortcut(stop, 'S');

  Beleuchtung := true;
  Umrandung := false;

  randomize;


 while ((obj<>frame) and (obj<>quit)) do begin

    obj:=action;

    if(obj = quit) then  break;
    if(obj = start) then do_work := true;
    if(obj = stop) then  do_work := false;
    if(obj=pressed) then do_work:=true;

    if (obj = frame) then break;

  if (obj=input)then begin
    first:=0;
    xmax := 300;
    WandleZahlInString(xmax,4.0,xmaxStr);
    ymax := 150;
    WandleZahlInString(ymax,4.0,ymaxStr);
    anfhoehe:=5;
    WandleZahlInString(anfhoehe,3.0,anfhoeheStr);
    b:=2.0;
    WandleZahlInString(b,3.2,bStr);
    Windstaerke:=5.0;
    WandleZahlInString(Windstaerke,3.2,WindstaerkeStr);
    q:=1;
    WandleZahlInString(q,3,qStr);
    repeat
      liesinteger(' Programm zur Simulation von Sandrippeln nach Nishimori - Schichtlnge : ', xmaxStr, xmax);
    until (xmax <m);
    repeat
      liesinteger(' Schichtbreite : ', ymaxStr, ymax);
    until ymax <n;
    liesinteger(' Schichthoehe : ', anfhoeheStr, anfhoehe);
    liesreal(' Faktor "b" : ',bStr, b);
    liesreal(' Windstaerke (0..) : ',WindstaerkeStr, Windstaerke);
    liesinteger(' Faktor "q" : ', qStr, q);
    grenze:=anfhoehe+1;
    WandleZahlInString(grenze,2.0,grenzeStr);
    liesinteger(' Grenze : ', grenzeStr, grenze);
    setzeBildschirmausschnitt(50,xm-50,50,ym-50);
    dimensioniereBildschirm(0,{xm} 1.*xmax,0,{ym}1.*ymax);
    init;
    zeigen(grenze);
  end;

  if ((obj=input)and(not first=1)) then begin
    liesreal(' Faktor "b" : ',bStr, b);
    liesreal(' Windstaerke (0..?) : ',WindstaerkeStr, Windstaerke);
    liesinteger(' Faktor "q" : ', qStr, q);
  END;

  if (do_work) then begin
    simu;
    zeigen(grenze);
    do_work:=false;
  end;


 end;
 programmende;

end.


